import { getEndpointPlugin } from "@smithy/middleware-endpoint";
import { getSerdePlugin } from "@smithy/middleware-serde";
import { Command as $Command } from "@smithy/smithy-client";
import { commonParams } from "../endpoint/EndpointParameters";
import { ListResourcesResponseFilterSensitiveLog, } from "../models/models_0";
import { de_ListResourcesCommand, se_ListResourcesCommand } from "../protocols/Aws_json1_1";
export { $Command };
export class ListResourcesCommand extends $Command
    .classBuilder()
    .ep(commonParams)
    .m(function (Command, cs, config, o) {
    return [
        getSerdePlugin(config, this.serialize, this.deserialize),
        getEndpointPlugin(config, Command.getEndpointParameterInstructions()),
    ];
})
    .s("WorkMailService", "ListResources", {})
    .n("WorkMailClient", "ListResourcesCommand")
    .f(void 0, ListResourcesResponseFilterSensitiveLog)
    .ser(se_ListResourcesCommand)
    .de(de_ListResourcesCommand)
    .build() {
}
